{
 Unit JmpMemo: TJumpMemo component.
 Copyright  1997 by Alexander Kuznetsov from Republican Center of Legal Information of the Republic of Kazakhstan.
 This component is freeware, and you can use it as you wish, but you can`t distribute or sale them.
 For all questions and suggestions about this component please send me a massage on the
 Borlands Delphi Forum to author named SANYAKING or e-mail sanhome@hotmail.com.
 Big thanks to Gerry Skolnik (skolnik@kapsch.co.at)
 for his component TBigText, because I get the scrolling from it
}
unit Jmpmemo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,StdCtrls,Printers;
{$M+}

type

  TJumpClick=procedure(Sender:TObject;JumpString:String)of Object;

  TJumpMemo = class(TCustomControl)
  private
   { Private declarations }
   FOnJumpClick:TJumpClick;
   FLines:TStrings;
   FSelWords:TStrings;
   JumpList:TStringList;
   FColor:TColor;
   FTextColor:TColor;
   FSelColor:TColor;
   FJumpColor:TColor;
   FFont:TFont;
   Border:TBorderStyle;
   FScrollBars:TScrollStyle;
   FileLoaded:Boolean;
   FShowPages:Boolean;
   MyCursor:Integer;
   FJumpLength:Integer;
   procedure Paint;override;
   procedure SetLines(Value: TStrings);
   procedure SetShowPages(Value: boolean);
   procedure SetSelWords(Value: TStrings);
   procedure SetFont(Fnt:TFont);
   procedure SetColor(Col:Tcolor);
   procedure SetSelColor(Col:Tcolor);
   procedure SetJumpColor(Col:Tcolor);
   procedure SetJumpLength(Value:Integer);
   procedure SetTextColor(Col:Tcolor);
   procedure SetBorder(Bor:TBorderStyle);
   procedure DoScroll(Which, Action, Thumb: longint);
   procedure WMHScroll(var M: TWMHScroll); message wm_HScroll;
   procedure WMVScroll(var M: TWMVScroll); message wm_VScroll;
   procedure WMSize(var M: TWMSize); message wm_Size;
   procedure WMGetDlgCode(var M: TWMGetDlgCode); message wm_GetDlgCode;
   procedure MouseMove(Shift:TShiftState;X,Y:Integer);override;
   procedure MouseDown(Button: TMouseButton;Shift:TShiftState;X,Y:Integer);override;
   procedure KeyDown(var Key: Word; Shift: TShiftState); override;
   procedure ReadJumps;
   Function GetWord(X,Y:integer):string;
  protected
   { Protected declarations }
   FRange: TPoint;
   FOrigin: TPoint;
   FClientSize: TPoint;
   FCharSize: TPoint;
   FOverhang: longint;
   FPageSize: longint;
   maxlen,scx:longint;
   maxstrlen:longint;
   crMyCurs:TCursor;
   procedure JumpClick;dynamic;
   procedure FontChanged(Sender: TObject);
   procedure RecalcRange;
   procedure InsertPages;
   procedure RemovePages;
   procedure CreateParams(var Params: TCreateParams);override;
   procedure ChangeScrollBars(Value: TScrollStyle);
   procedure SetScrollBars;
  public
   { Public declarations }
   PageCount:integer;
   IsJump:boolean;
   JmpStr:string;
   property JumpWords:TStringList read JumpList;
   constructor Create(AnOwner: TComponent); override;
   destructor Destroy; override;
   procedure LoadFromFile(const FileName:string);
   procedure ScrollTo(X, Y: longint);
   procedure Add(const Str:string);
   procedure Print(const fn:string;stpg,endpg:longint;infile,allfile:boolean);
   function GotoWord(const Str:string;curpos:longint;Up:Boolean):longint;
   function GetPos(const Str:string;curpos:longint):longint;
   function Search(srstr:string;Down:boolean;posy:longint;var lasty:longint):boolean;
   function GetCurPos:longint;
  published
   { Published declarations }
   property Font:TFont read FFont write SetFont;
   property Color:TColor read FColor write SetColor;
   property Lines:TStrings read FLines write SetLines;
   property SelWords:TStrings read FSelWords write SetSelWords;
   property SelectColor:TColor read FSelColor write SetSelColor;
   property JumpColor:TColor read FJumpColor write SetJumpColor;
   property TextColor:TColor read FTextColor write SetTextColor;
   property JumpPointLength:Integer read FJumpLength write SetJumpLength;
   property Align;
   property HelpContext;
   property BorderStyle:TBorderStyle read Border write SetBorder default bsNone;
   property ScrollBars: TScrollStyle read FScrollBars write ChangeScrollBars default ssNone;
   property ShowPages:Boolean read FShowPages write SetShowPages default false;
   property TabStop;
   property OnJumpClick:TJumpClick read FOnJumpClick write FOnJumpClick;
  end;
{$M-}

procedure Register;

implementation
{$R JMPMEMO.RES}

type
  TScrollKey = record
    sKey: Byte;
    Ctrl: Boolean;
    SBar: Byte;
    Action: Byte;
  end;

{ Scroll keys table }

const
  ScrollKeyCount = 16;
  ScrollKeys: array[1..ScrollKeyCount] of TScrollKey = (
    (sKey: vk_Left;  Ctrl: False; SBar: sb_Horz; Action: sb_LineUp),
    (sKey: vk_Right; Ctrl: False; SBar: sb_Horz; Action: sb_LineDown),
    (sKey: vk_Left;  Ctrl: True;  SBar: sb_Horz; Action: sb_PageUp),
    (sKey: vk_Right; Ctrl: True;  SBar: sb_Horz; Action: sb_PageDown),
    (sKey: vk_Home;  Ctrl: False; SBar: sb_Vert; Action: sb_Top),
    (sKey: vk_End;   Ctrl: False; SBar: sb_Vert; Action: sb_Bottom),
    (sKey: vk_Up;    Ctrl: False; SBar: sb_Vert; Action: sb_LineUp),
    (sKey: vk_Down;  Ctrl: False; SBar: sb_Vert; Action: sb_LineDown),
    (sKey: vk_Prior; Ctrl: False; SBar: sb_Vert; Action: sb_PageUp),
    (sKey: vk_Next;  Ctrl: False; SBar: sb_Vert; Action: sb_PageDown),
    (sKey: vk_F1;    Ctrl: False; SBar: sb_Vert; Action: sb_PageDown),
    (sKey: vk_F2;    Ctrl: False; SBar: sb_Vert; Action: sb_PageUp),
    (sKey: vk_F3;    Ctrl: False; SBar: sb_Vert; Action: sb_Top),
    (sKey: vk_F4;    Ctrl: False; SBar: sb_Vert; Action: sb_Bottom),
    (sKey: vk_Home;  Ctrl: True;  SBar: sb_Horz; Action: sb_Top),
    (sKey: vk_End;   Ctrl: True;  SBar: sb_Horz; Action: sb_Bottom));


function UpStr(const s:string):string;
 function UpChar(const St:char):char;
 var ch:char;
 begin
  case St of
   {English char`s}
   'A':ch:='';
   'a':ch:='';'b':ch:='';'B':ch:='';'c':ch:='';'C':ch:='';'d':ch:='D';
   'e':ch:='';'E':ch:='';'f':ch:='F';'g':ch:='G';'h':ch:='H';'H':ch:='';
   'i':ch:='I';'j':ch:='J';'k':ch:='';'K':ch:='';'l':ch:='L';'M':ch:='';
   'm':ch:='';'n':ch:='N';'o':ch:='';'O':ch:='';'p':ch:='';'P':ch:='';
   'q':ch:='Q';'r':ch:='R';'s':ch:='S';'t':ch:='';'T':ch:='';
   'u':ch:='U';'v':ch:='V';'w':ch:='W';'x':ch:='';'X':ch:='';
   'y':ch:='Y';'z':ch:='Z';
   {Russian char`s}
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';'':ch:='';'':ch:='';'':ch:='';
   '':ch:='';
  else ch:=St;
  end;
   UpChar:=ch;
 end;
var i,Len:integer;
    temp:string;
    mes:array[0..512]of char;
begin
 Len:=Length(s);
 temp:=s;
 for i:=1 to len do temp[i]:=UpChar(s[i]);
 result:=temp;
end;

function Max(i1,i2:longint):longint;
begin
 if i1>i2 then result:=i1
 else result:=i2;
end;

function Min(i1,i2:longint):longint;
begin
 if i1<i2 then result:=i1
 else result:=i2;
end;

Constructor TJumpMemo.Create(AnOwner: TComponent);
begin
 inherited Create(AnOwner);
 try
 FLines:=TStringList.Create;
 except MessageBox(0,'Can`t create List for text lines','Error',Mb_OK);
  Exit;
 end;
 try
 FSelWords:=TStringList.Create;
 except MessageBox(0,'Can`t create List for Selected words','Error',Mb_OK);
  Exit;
 end;
 try
 JumpList:=TStringList.Create;
 JumpList.Sorted:=True;
 except MessageBox(0,'Can`t create List for Jump words','Error',Mb_OK);
  Exit;
 end;
 FColor:=ClWhite;
 FSelColor:=ClRed;
 FJumpColor:=ClGreen;
 FTextColor:=ClBlack;
 FFont:=TFont.Create;
 FFont.Name:='Courier New';
 FFont.Color:=FTextColor;
 maxstrlen:=0;
 Width:=200;
 Height:=300;
 FFont.OnChange := FontChanged;
 FontChanged(nil);
 Align:=alNone;
 FJumpLength:=7;
 FileLoaded:=False;
 PageCount:=0;
 MyCursor:=1;
 IsJump:=False;
 scx:=0;
 JmpStr:='';
 try
 crMyCurs:=LoadCursor(HInstance, 'HANDCURSOR');
 Screen.Cursors[MyCursor]:=crMyCurs;
 if crMyCurs=0 then MyCursor:=crUpArrow;
 except
  MyCursor:=crUpArrow;
 end;
 Repaint;
end;


destructor TJumpMemo.Destroy;
begin
 FLines.Free;
 FSelWords.Free;
 FFont.Free;
 inherited Destroy;
end;

procedure TJumpMemo.CreateParams(var Params: TCreateParams);
const
  ScrollBar: array[TScrollStyle] of LongInt = (0, WS_HSCROLL, WS_VSCROLL,
    WS_HSCROLL or WS_VSCROLL);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ScrollBar[FScrollBars];
end;

procedure TJumpMemo.SetLines(Value: TStrings);
begin
  FLines.Assign(Value);
  if FShowPages then
  begin
   RemovePages;
   InsertPages;
  end;
  ReadJumps;
  Repaint;
end;

procedure TJumpMemo.SetSelWords(Value: TStrings);
begin
  FSelWords.Assign(Value);
  Repaint;
end;

procedure TJumpMemo.ChangeScrollBars(Value: TScrollStyle);
begin
  if FScrollBars <> Value then
  begin
    FScrollBars := Value;
    RecreateWnd;
  end;
end;

procedure TJumpMemo.SetScrollBars;
begin
  if HandleAllocated then
  begin
    if (FScrollBars = ssHorizontal) or (FScrollBars = ssBoth) then
    begin
      SetScrollRange(Handle, sb_Horz, 0, Max(1, FRange.X), False);
      SetScrollPos(Handle, sb_Horz, FOrigin.X, True);
    end;
    if (FScrollBars = ssVertical) or (FScrollBars = ssBoth) then
    begin
      SetScrollRange(Handle, sb_Vert, 0, Max(1, FRange.Y), False);
      SetScrollPos(Handle, sb_Vert, FOrigin.Y, True);
    end;
  end;
end;

procedure TJumpMemo.LoadFromFile(const FileName:string);
begin
 FLines.Clear;
 try
 FLines.LoadFromFile(FileName);
 except MessageBox(0,'Can`t load document from file !','Error',Mb_OK+MB_ICONSTOP);
 end;
 FileLoaded:=true;
 ReadJumps;
 if FShowPages then
 begin
  RemovePages;
  InsertPages;
 end;
 RecalcRange;
 Repaint;
 ScrollTo(0,0);
end;

procedure TJumpMemo.Paint;
var
y,n,c,jumpc,wp,swc,j,cury,x,i:longint;
R: TRect;
flag : Word;
tmpstr:string;
tmpwrd:string;
err:array[0..50]of char;
err1:array[0..50]of char;
outstr:array[0..255]of char;
begin
 jumpc:=JumpList.Count;
 SetViewportOrg(Canvas.Handle, -FOrigin.X * FCharSize.X, 0);
 Canvas.Brush.Style:=bsSolid;
 Canvas.Brush.Color:=FColor;
 y:=0;
 if Border=bsSingle then
 begin
  Canvas.Pen.Style:=psSolid;
  Canvas.Pen.Color:=clBlack;
  Canvas.Pen.Width:=1;
  Canvas.Rectangle(0,0,Width,Height);
  x:=FOrigin.X+1;
  Y:=1;
 end
 else
 begin
  x:=FOrigin.X;
 end;
 if FLines.Count<>0 then
 begin
  Canvas.Font:=FFont;
  cury:=FOrigin.Y;
  i:=0;
  Canvas.Brush.Style:=bsSolid;
  while (i<FPageSize)and (i<FLines.Count)do
  begin
  try
   if pos('------------------------------ Page ',FLines[i+cury])>0then
   begin
    Canvas.Font.Color:=clBlue;
    Canvas.TextOut(x,FCharSize.Y * i+y,FLines[i+cury]);
    Canvas.Font.Color:=FFont.Color;
   end
   else
    Canvas.TextOut(x,FCharSize.Y * i+y,FLines[i+cury]);
    try
     swc:=FSelWords.Count;
     if swc<>0 then
     begin
      for j:=0 to swc-1 do
      begin
       Canvas.Font.Color:=FSelColor;
       wp:=pos(UpStr(FSelWords[j]),UpStr(FLines[i+cury]));
       if wp>0 then
       begin
        tmpstr:='';
        for n:=1 to wp-1 do tmpstr:=tmpstr+FLines[i+cury][n];
        tmpwrd:='';
        for n:=wp to wp+Length(FSelWords[j])-1 do tmpwrd:=tmpwrd+FLines[i+cury][n];
        Canvas.TextOut(x+Canvas.TextWidth(tmpstr),i*FCharSize.Y+Y,tmpwrd);
       end;
      end;
     end;
    except MessageBox(0,'Can`t draw selected words !','Error:',Mb_OK+MB_ICONSTOP);
    end;
    try
     if jumpc<>0 then
     begin
      for j:=0 to jumpc-1 do
      begin
       Canvas.Font.Color:=FJumpColor;
       Canvas.Font.Style:=Canvas.Font.Style+[fsUnderLine];
       wp:=pos(UpStr(JumpList[j]),UpStr(FLines[i+cury]));
       if wp>0 then
       begin
        tmpstr:='';
        for n:=1 to wp-1 do tmpstr:=tmpstr+FLines[i+cury][n];
        tmpwrd:='';
        Canvas.Font.Color:=Color;
        Canvas.TextOut(x+Canvas.TextWidth(tmpstr),i*FCharSize.Y+Y,'~');
        Canvas.Font.Color:=FJumpColor;
        for n:=wp+1 to wp+Length(JumpList[j])-1 do tmpwrd:=tmpwrd+FLines[i+cury][n];
        Canvas.TextOut(x+Canvas.TextWidth(tmpstr+'~'),i*FCharSize.Y+Y,tmpwrd);
       end;
      end;
     end;
    except MessageBox(0,'Can`t draw jump points','Error',Mb_OK);
    end;
    Canvas.Font:=FFont;
    if (i+cury)=(FLines.Count-1) then Exit;
    inc(i);
   except
    on E:ERangeError do
    begin
     StrPCopy(err,'Can`t draw line  '+IntToStr(i)+' . Message :"'+E.Message+'"');
     MessageBox(0,err,'Error',MB_OK);
     Exit;
    end;
   end;
  end;
 end;
end;

procedure TJumpMemo.SetFont(Fnt:TFont);
begin
 FFont.Assign(Fnt);
end;

procedure TJumpMemo.FontChanged(Sender: TObject);
var
  DC: HDC;
  Save: THandle;
  Metrics: TTextMetric;
  Temp: String;
begin
  DC := GetDC(0);
  Save := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, Save);
  ReleaseDC(0, DC);
  with Metrics do
  begin
    FCharSize.X := tmAveCharWidth;
    FCharSize.Y := tmHeight + tmExternalLeading;
    FOverhang   := Max(tmOverhang, tmMaxCharWidth - tmAveCharWidth);
    RecalcRange;
    Repaint;
  end;
  scx:=0;
  ScrollTo(0,FOrigin.Y);
end;

procedure TJumpMemo.SetColor(Col:Tcolor);
begin
 if Col<>FColor then
 begin
  Fcolor:=Col;
  Repaint;
 end;
end;

procedure TJumpMemo.SetSelColor(Col:Tcolor);
begin
 if Col<>FSelColor then
 begin
  FSelcolor:=Col;
  Repaint;
 end;
end;

procedure TJumpMemo.SetJumpColor(Col:Tcolor);
begin
 if Col<>FJumpColor then
 begin
  FJumpcolor:=Col;
  Repaint;
 end;
end;

procedure TJumpMemo.SetJumpLength(Value:Integer);
begin
 if Value<>FJumpLength then
 begin
  FJumpLength:=Value;
  ReadJumps;
  Repaint;
 end;
end;

procedure TJumpMemo.SetTextColor(Col:Tcolor);
begin
 if Col<>FTextColor then
 begin
  FTextColor:=Col;
  FFont.Color:=FTextColor;
  Repaint;
 end;
end;

procedure TJumpMemo.SetBorder(Bor:TBorderStyle);
begin
 if Bor<>Border then
 begin
  Border:=Bor;
  Repaint;
 end;
end;

procedure TJumpMemo.WMHScroll(var M: TWMHScroll);
begin
  DoScroll(sb_Horz, M.ScrollCode, M.Pos);
end;

procedure TJumpMemo.WMVScroll(var M: TWMVScroll);
begin
  DoScroll(sb_Vert, M.ScrollCode, M.Pos);
end;

procedure TJumpMemo.WMSize(var M: TWMSize);
begin
  inherited;
  RecalcRange;
end;

procedure TJumpMemo.WMGetDlgCode(var M: TWMGetDlgCode);
begin
  M.Result := dlgc_WantArrows or dlgc_WantChars;
end;


procedure TJumpMemo.KeyDown(var Key: Word; Shift: TShiftState);
var
  I: Integer;
begin
  inherited KeyDown(Key, Shift);
  if (Key = vk_F1)then
  begin
   Application.HelpContext(HelpContext);
   Exit;
  end;
  if Key <> 0 then
  begin
   for I := 1 to ScrollKeyCount do
   with ScrollKeys[I] do
    if (sKey = Key) and (Ctrl = (Shift = [ssCtrl])) then
    begin
     DoScroll(SBar, Action, 0);
     Exit;
    end;
  end;
end;

procedure TJumpMemo.DoScroll(Which, Action, Thumb: longint);
var
  X, Y: longint;
function GetNewPos(Pos, Page, Range: longint): longint;
begin
  case Action of
    sb_LineUp: GetNewPos := Pos - 1;
    sb_LineDown: GetNewPos := Pos + 1;
    sb_PageUp: GetNewPos := Pos - Page;
    sb_PageDown: GetNewPos := Pos + Page;
    sb_Top: GetNewPos := 0;
    sb_Bottom: GetNewPos := Range;
    sb_ThumbPosition,
    sb_ThumbTrack    : GetNewPos := Thumb;
  else
    GetNewPos := Pos;
  end;
end;
begin
  X := FOrigin.X;
  Y := FOrigin.Y;
  case Which of
    sb_Horz: X := GetNewPos(X, FClientSize.X div 2, FRange.X);
    sb_Vert: Y := GetNewPos(Y, FClientSize.Y, FRange.Y);
  end;
  ScrollTo(X, Y);
end;

procedure TJumpMemo.ScrollTo(X, Y: longint);
var
  R: TRect;
  OldOrigin: TPoint;
begin
  X := Max(0, Min(X, FRange.X));
  Y := Max(0, Min(Y, FRange.Y));
  if (X <> FOrigin.X) or (Y <> FOrigin.Y) then
  begin
    OldOrigin := FOrigin;
    FOrigin.X := X;
    FOrigin.Y := Y;
    if HandleAllocated then
    begin
      R := Parent.ClientRect;
      if (OldOrigin.X - X)<0 then scx:=scx+((OldOrigin.X - X) * FCharSize.X)+1*abs((OldOrigin.X - X))
      else if (OldOrigin.X - X)=0 then
      else scx:=scx+((OldOrigin.X - X) * FCharSize.X)-1*abs((OldOrigin.X - X));
      ScrollWindowEx(Handle, (OldOrigin.X - X) * FCharSize.X, (OldOrigin.Y - Y) * FCharSize.Y,
                     nil, @R, 0, @R, 0);
      if Y <> OldOrigin.Y then
        SetScrollPos(Handle, sb_Vert, Y, True);
      if X <> OldOrigin.X then
        SetScrollPos(Handle, sb_Horz, X, True);
    InvalidateRect(Handle, nil, true);
    Update;
    end;
  end;
end;

procedure TJumpMemo.RecalcRange;
begin
  if HandleAllocated then
  begin
    FClientSize.X := ClientWidth div FCharSize.X;
    FClientSize.Y := ClientHeight div FCharSize.Y;
    FPageSize := FClientSize.Y;
    FRange.X := Max(0, maxstrlen*5 div 4 - FClientSize.X);
    FRange.Y := Max(0, FLines.Count - FClientSize.Y);
    if Border=bsSingle then
    begin
     FRange.X:=FRange.X+1;
     FRange.Y:=FRange.Y+1;
    end;
    ScrollTo(Min(FOrigin.X, FRange.X), Min(FOrigin.Y, FRange.Y));
    SetScrollBars;
  end;
end;

procedure TJumpMemo.Add(const Str:string);
begin
 try
  FLines.Add(str);
  ReadJumps;
  if FShowPages then
  begin
   RemovePages;
   InsertPages;
  end;
  RecalcRange;
  Repaint;
 except MessageBox(0,'Can`t add line in document !','Error',Mb_OK);
 end;
end;

function TJumpMemo.GotoWord(const Str:string;curpos:longint;Up:Boolean):longint;
var wp,i:longint;
begin
 i:=curpos;
 if Up=True then
 begin
 while i < FLines.Count do
 begin
  wp:=pos(UpStr(Str),UpStr(FLines[i]));
  if wp>0 then
  begin
   ScrollTo(0,i);
   SetScrollBars;
   result:=i;
   exit;
  end;
  inc(i);
 end;
 end
 else
 begin
 while i >0 do
 begin
  wp:=pos(UpStr(Str),UpStr(FLines[i]));
  if wp>0 then
  begin
   ScrollTo(0,i);
   SetScrollBars;
   result:=i;
   exit;
  end;
  dec(i);
 end;
 end;
  result:=curpos;
end;

function TJumpMemo.GetPos(const Str:string;curpos:longint):longint;
var wp,i:longint;
begin
 i:=curpos;
 while i < FLines.Count do
 begin
  wp:=pos(UpStr(Str),UpStr(FLines[i]));
  if wp>0 then
  begin
   result:=i;
   exit;
  end;
  inc(i);
 end;
  result:=curpos;
end;

function TJumpMemo.GetCurPos:longint;
begin
 result:=FOrigin.Y;
end;

procedure TJumpMemo.Print(const fn:string;stpg,endpg:longint;infile,allfile:boolean);
var
 Xs,Ys,y,i,Line,pg: longint;
 PrintTextF:System.TextFile;
begin
 if endpg<stpg then
 begin
  MessageBox(0,'Wrong pages range. Call printer procedure again','Error',mb_ok);
  Exit;
 end;
 if infile=true then
 begin
  AssignFile(PrintTextF,fn);
  Rewrite(PrintTextF);
  if allfile=True then
  begin
   for i:=0 to FLines.Count-1 do WriteLn(PrintTextF,FLines[i]);
   System.Close(PrintTextF);
  end
  else
  begin
   for i:=stpg to endpg do
   begin
    Line:=(i-1)*51;
    while Line<(i*51) do
    begin
     if Line=FLines.Count-1 then
     begin
      System.Close(PrintTextF);
      Exit;
     end;
     WriteLn(PrintTextF,FLines[Line]);
     Line:=Line+1;
    end;
   end;
   System.Close(PrintTextF);
   Exit;
  end;
 end
 else
 begin
  if AllFile=True then
  begin
   try
    Printer.Title:='Printing Doc';
    Printer.BeginDoc;
    Printer.Canvas.Font:=FFont;
    Printer.Canvas.Font.Size:=FFont.Size;
    Xs:=(Printer.PageWidth-100)div 80;
    Xs:=Xs*4;
    Ys:=(Printer.PageHeight-800)div 45;
    pg:=1;
    for i:=0 to FLines.Count-1 do
    begin
     Printer.Canvas.TextOut(Xs,i*Ys,FLines[i]);
     if i=pg*51 then
     begin
      pg:=pg+1;
      Printer.NewPage;
     end;
    end;
    Printer.EndDoc;
   except
    MessageBox(0,'Can`t put document on printer','Error',mb_Ok);
    Exit;
   end;
   Exit;
  end
  else
  begin
   for i:=stpg to endpg do
   begin
    try
     Printer.Title:='Printing Doc';
     Printer.BeginDoc;
     Printer.Canvas.Font:=FFont;
     Xs:=(Printer.PageWidth-100)div 80;
     Ys:=(Printer.PageHeight-800)div 45;
     Printer.Canvas.Font.Size:=FFont.Size;
     Xs:=Xs*4;
     Line:=(i-1)*51;
     y:=Ys;
     while Line<(i*51) do
     begin
      if Line=FLines.Count-1 then
      begin
       Printer.EndDoc;
       Exit;
      end;
      Printer.Canvas.TextOut(Xs,400+y,FLines[Line]);
      y:=y+Ys;
      Line:=Line+1;
     end;
     Printer.EndDoc;
    except
     MessageBox(0,'Can`t put document on the printer','Error',mb_Ok);
     Printer.EndDoc;
     Exit;
    end;
   end;
  end;
 end;
end;

function TJumpMemo.GetWord(X,Y:integer):string;
label st1,st2,done;
var x1,y1,xw,yw,i,stw,enw:integer;
    unvsstr,tmpw,tmst:string;
    strt:string;
begin
 x1:=x;y1:=y;
 stw:=0;
 enw:=0;
 yw:=FOrigin.Y+(Y1 div FCharSize.Y);
 if yw > FLines.Count-1 then
 begin
  If IsJump then
  begin
   IsJump:=False;
   Screen.Cursor:=crDefault;
  end;
  result:=' ';
  Exit;
 end;
 if Length(FLines[yw])=0 then
 begin
  result:=' ';
  Exit;
 end;
 if x1 > Canvas.TextWidth(FLines[yw]) then
 begin
  If IsJump then
  begin
   IsJump:=False;
   Screen.Cursor:=crDefault;
  end;
  result:=' ';
  Exit;
 end;
 for xw:=1 to Length(FLines[yw])do
 begin
  tmst:='';
  i:=1;
  for i:=1 to xw-1 do tmst:=tmst+FLines[yw][i];
  if (x1>(Canvas.TextWidth(tmst)+scx-
                                  Canvas.TextWidth(FLines[yw][xw])))
      and
      (x1<(Canvas.TextWidth(tmst)+scx+
                                   Canvas.TextWidth(FLines[yw][xw])))then
      goto done;
 end;
done:
 strt:=FLines[yw];
 tmpw:='';
  for i:=xw downto 1+FOrigin.X do {Searching first division char from the right}
  begin
  if (strt[i]='.') or (strt[i]=',') or (strt[i]=':') or (strt[i]=';') or (strt[i]='-') or (strt[i]='(') or( strt[i]=')') or
      (strt[i]='_') or (strt[i]='#')or (strt[i]='[')or (strt[i]=']')or (strt[i]='{')or (strt[i]='}')or (strt[i]=' ')then
       goto st1;
   stw:=i;
  end;
st1:
  for i:=xw to length(strt) do {Searching division char on the left or EOL }
  begin
  if (strt[i]='.') or (strt[i]=',') or (strt[i]=':') or (strt[i]=';') or (strt[i]='-') or (strt[i]='(') or( strt[i]=')') or
      (strt[i]='_') or (strt[i]='#')or (strt[i]='[')or (strt[i]=']')or (strt[i]='{')or (strt[i]='}')or (strt[i]=' ')then
       goto st2;
   enw:=i;
  end;
st2:
  for i:=stw to enw do
  begin
   tmpw:=tmpw+strt[i];
  end;
 result:=tmpw;
end;

procedure TJumpMemo.MouseMove(Shift:TShiftState;X,Y:Integer);
var st:string;
begin
 inherited MouseMove(Shift,X,Y);
 if FLines.Count>0 then
 begin
  try
   st:=GetWord(X,Y);
   if Length(st)<>0 then
   begin
   if (st[1]='~')and(Y>=0)and(Y<=Width) then
   begin
    Screen.Cursor:=MyCursor;
    IsJump:=True;
    JmpStr:=st;
   end
   else
   begin
    IsJump:=False;
    Screen.Cursor:=crDefault;
   end;
   end;
  except
   MessageBox(0,'Can`t recognize word under cursor!','Error',Mb_OK);
   Exit;
  end;
 end;
end;

procedure TJumpMemo.MouseDown(Button: TMouseButton;Shift:TShiftState;X,Y:Integer);
begin
 inherited MouseDown(Button,Shift,X,Y);
 if Button=mbLeft then
 begin
  if IsJump then JumpClick;
 end;
end;

procedure TJumpMemo.JumpClick;
begin
  if Assigned(FOnJumpClick)then
  begin
   Screen.Cursor:=crDefault;
   FOnJumpClick(self,JmpStr);
  end;
end;

function TJumpMemo.Search(srstr:string;Down:boolean;posy:longint;var lasty:longint):boolean;
var
 cury,n,j,index,i,lc,X,Y:longint;
 fnd:   longint;
 tmpstr:string;
 tmpwrd:string;
begin
 Repaint;
 X:=FOrigin.X;
 Y:=posy;
 LC:=FLines.Count;
 i:=y;
 if Down then
 begin
  if i=lc-1 then i:=lc-2;
  while i<lc-1 do
  begin
   i:=i+1;
   fnd:=pos(UpStr(srstr),UpStr(FLines[i]));
   if fnd>0 then
   begin
    index:=i;
    lasty:=i;
    i:=lc;
   end;
  end;
 end
 else
 begin
  if i=0 then i:=1;
  while i>0 do
  begin
   i:=i-1;
   fnd:=pos(UpStr(srstr),UpStr(FLines[i]));
   if fnd>0 then
   begin
    index:=i;
    lasty:=i;
    i:=0;
   end;
  end;
 end;
 if fnd>0 then
 begin
  {Check that searching word not in selword or in jumps}
  if FSelWords.Count >0 then
  begin
   for j:=0 to FSelWords.Count-1 do
   if pos(UpStr(srstr),UpStr(FSelWords[j]))>0 then
   begin
    ShowMessage('Error! Searching Word in selected words!');
    result:=False;
    Exit;
   end;
  end;
  if JumpList.Count >0 then
  begin
   for j:=0 to JumpList.Count-1 do
   if pos(UpStr(srstr),UpStr(JumpList[j]))>0 then
   begin
    ShowMessage('Error ! Searching Word in jump words!');
    result:=False;
    Exit;
   end;
  end;
  ScrollTo(x,index);
  cury:=FOrigin.Y;
  i:=0;
  while (i<FPageSize)and (i<FLines.Count)do
  begin
   if (i+cury)=index then
   begin
    tmpstr:='';
    for n:=1 to fnd-1 do tmpstr:=tmpstr+FLines[i+cury][n];
    tmpwrd:='';
    for n:=fnd to fnd+Length(srstr)-1 do tmpwrd:=tmpwrd+FLines[i+cury][n];
    Canvas.Brush.Color:=clActiveCaption;
    Canvas.Font.Color:=clWhite;
    Canvas.TextOut(x+Canvas.TextWidth(tmpstr),i*FCharSize.Y,tmpwrd);
    result:=true;
   end;
   i:=i+1;
  end;
 end
 else
 begin
  result:=False;
 end;
end;

procedure TJumpMemo.ReadJumps;
var
 jump,i,j:longint;
 index:integer;
 temp:string;
begin
 maxstrlen:=0;
 JumpList.Clear;
 for i:=0 to FLines.Count-1 do
 begin
  if Length(FLines[i])>maxstrlen then maxstrlen:=Length(FLines[i]);
  temp:='';
  jump:=pos(UpStr('~'),UpStr(FLines[i]));
  if jump>0 then
  begin
   for j:=0 to FJumpLength do
   begin
    if jump+j>Length(FLines[i])then break;
    temp:=temp+FLines[i][jump+j];
   end;
   if not JumpList.Find(temp,index)then JumpList.Add(temp);
  end;
 end;
end;

procedure TJumpMemo.InsertPages;
var
 i,pgc:longint;
begin
 pgc:=FLines.Count div 44;
 PageCount:=pgc+1;
 for i:=0 to pgc do
 begin
  try
   FLines.Insert((i*44)+i,'------------------------------ Page '
   +IntToStr(i+1)+'------------------------------------');
  except MessageBox(0,'Can`t insert page marker !','Error',Mb_OK);
   RecalcRange;
   Repaint;
   ScrollTo(0,0);
   exit;
  end;
 end;
 RecalcRange;
 Repaint;
 ScrollTo(0,0);
end;

procedure TJumpMemo.RemovePages;
var i:longint;
begin
 PageCount:=0;
 for i:=FLines.Count-1 downto 0 do
 begin
  try
   if pos('------------------------------ Page ',FLines[i])>0 then FLines.Delete(i);
  except MessageBox(0,'Can`t remove page marker !','Error',Mb_OK);
   RecalcRange;
   Repaint;
   ScrollTo(0,0);
   exit;
  end;
 end;
 RecalcRange;
 Repaint;
 ScrollTo(0,0);
end;

procedure TJumpMemo.SetShowPages(Value:boolean);
begin
 if FShowPages<>Value then
 begin
  FShowPages:=Value;
  if FShowPages then
  begin
   InsertPages;
  end
  else
  begin
   RemovePages;
  end
 end;
end;

procedure Register;
begin
  RegisterComponents('AK Soft', [TJumpMemo]);
end;

end.
